{-# LANGUAGE TypeFamilies, CPP #-}
module NoSlow.Backend.Vector.Primitive (
  module Data.Vector.Primitive,

  enumFromTo_Int, index, append, update, and,
  zip, zip3, unzip, pair, from2, fst, snd, triple, from3
) where

import NoSlow.Util.Computation
import NoSlow.Util.Base ( Unsupported(..) )
import qualified Data.Vector.Primitive as V
import Data.Vector.Primitive

import Prelude hiding ( and, fst, snd, zip, zip3, unzip )

instance DeepSeq (V.Vector a)

instance (TestData a, V.Prim a) => TestData (V.Vector a) where
  testData = testList

instance V.Prim a => ListLike V.Vector a where
  fromList = V.fromList

enumFromTo_Int :: Int -> Int -> V.Vector Int
{-# INLINE enumFromTo_Int #-}
enumFromTo_Int = V.enumFromTo

index :: V.Prim a => V.Vector a -> Int -> a
{-# INLINE index #-}
index = (V.!)

append :: V.Prim a => V.Vector a -> V.Vector a -> V.Vector a
{-# INLINE append #-}
append = (V.++)

and = Unsupported
update = Unsupported

zip = Unsupported
zip3 = Unsupported
unzip = Unsupported
pair = Unsupported
from2 = Unsupported
fst = Unsupported
snd = Unsupported
triple = Unsupported
from3 = Unsupported

